//
// C++ Interface: action
//
// Description: 
//
//
// Author: Szymon Acedanski <accek@podlesie.net>, (C) 2004
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qwidget.h>

class Ar3cMonitor;

class Action : public QObject {
    Q_OBJECT

protected:
    Ar3cMonitor* Owner;

public:
    Action(Ar3cMonitor *owner = 0, const char *name = 0);

public slots:
    virtual void run() = 0;
};


class AcQuit : public Action {
    Q_OBJECT

public:
    AcQuit(Ar3cMonitor* owner, const char* name = 0)
        : Action(owner, name) { }

public slots:
    void run();
};


class AcNop : public Action {
    Q_OBJECT

public:
    AcNop(Ar3cMonitor* owner, const char* name = 0)
        : Action(owner, name) { }

public slots:
    void run();
};


class AcDebug : public Action {
    Q_OBJECT

private:
    char* info;

public:
    AcDebug(const char* info, Ar3cMonitor* owner, const char* name = 0);
    ~AcDebug();

public slots:
    void run();
};


class AcChTab : public Action {
    Q_OBJECT

private:
    int tab;

public:
    AcChTab(int tab, Ar3cMonitor* owner, const char* name = 0);

public slots:
    void run();
};


class AcSignal : public Action {
    Q_OBJECT

public:
    AcSignal(Ar3cMonitor* owner, const char* name = 0);

public slots:
    void run();

signals:
    void sig();
};

