/*
 * AR-3c Monitor
 *
 * 	version 2.3
 * 
 * Copyright (C) 2006, 2007  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * See COPYING for license information
 *
 */

#include <qwidget.h>
#include <qstring.h>
#include <qcolor.h>
#include <qlayout.h>

#include "bufferedwidget.h"
#include "niceformat.h"

struct line {
	int x1, x2, y1, y2;
};

class MeterAWidget : public BufferedWidget {
	Q_OBJECT

private:
	QColor color;
	QString caption;
	QString unit;
	QString old_niceFormat;
	struct line old_line;
	float angle;
	int scale;
	int unipolar;
	int show_value;
	int along;
	prec_t prec;

	int analogIndex, oldvalid;
	float max_value, min_value, unit_value, old_value;
	struct line resolveLinePos(float v);

	QString niceFormat(float v);

protected:
	void paint(QPainter *p);

public:
	MeterAWidget(int _analogIndex, QColor _color, float _maxValue,
			float _minValue, float _unitValue, int _angle,
			int _scale, QString _caption, QString _unit,
			unsigned long flags, prec_t _prec, QWidget *parent = 0,
			const char *name = 0, Qt::WFlags f = 0);

public slots:
	void updateMeter();

signals:
	void sigUpdLabel(const QString &s);
};
