//
// C++ Interface: binarygraph
//
// Description: 
//
//
// Author: Szymon Acedanski <accek@podlesie.net>, (C) 2004
// Copyright (C) 2005, 2006  Krzysztof Mazur <krzysiek@podlesie.net>
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qcolor.h>
#include <qstring.h>

#include "control.h"
#include "bufferedwidget.h"

class QPainter;
class QWidget;

class BinaryGraph : public BufferedWidget {
	Q_OBJECT
private:
	QColor icolor;
	QColor acolor;
	QString symbol;
	int physical;
	int old_pos;

protected:
	void paint(QPainter *p);
	void mousePressEvent(QMouseEvent *e);
	void mouseMoveEvent(QMouseEvent *e);
	void mouseReleaseEvent(QMouseEvent *e);

public:
	 BinaryGraph(int _physical, const QColor &_acolor,
			const QColor &_icolor, const QString &_symbol,
			QWidget *parent = 0, const char *name = 0,
			Qt::WFlags f = 0);
};
