//
// C++ Implementation: myseparator
//
// Description: 
//
//
// Author: Szymon Acedanski <accek@podlesie.net>, (C) 2004
// Copyright (C) 2006  Krzysztof Mazur <krzysiek@podlesie.net>	
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qpainter.h>
#include <qpixmap.h>

#include "bufferedwidget.h"
#include <ar3cmonitor.h>
#if QT_VERSION >= 0x40000
# include <QKeyEvent>
#endif

#if QT_VERSION < 0x40000

BufferedWidget::BufferedWidget(QWidget *parent, const char *name, Qt::WFlags f)
	: QWidget(parent, name, f)
{
	setFocusPolicy(QT_STRONG_FOCUS);
#if QT_VERSION >= 0x30000
	setBackgroundMode(Qt::NoBackground);
#else
	setBackgroundMode(NoBackground);
#endif
}

void BufferedWidget::paintEvent(QPaintEvent *)
{
	QPixmap pm(size());
	QPainter p(&pm, this);
	p.fillRect(rect(), bgcolor);

	paint(&p);

	p.end();
	bitBlt(this, 0, 0, &pm);
}
	
void BufferedWidget::setBackgroundColor(QColor color)
{
	bgcolor = color;
}

QColor BufferedWidget::getBackgroundColor() const
{
	return bgcolor;
}

#else

/* Widgets in Qt4 are backbuffered by default */

BufferedWidget::BufferedWidget(QWidget *parent, const char *name, Qt::WFlags f)
    : QWidget(parent, name, f)
{
	setFocusPolicy(QT_STRONG_FOCUS);
	setBackgroundColor(Qt::black);
#if QT_VERSION >= 0x40100
	setAutoFillBackground(true);
#endif
}

void BufferedWidget::paintEvent(QPaintEvent *)
{
	QPainter p(this);
	paint(&p);
}

#endif

void BufferedWidget::keyPressEvent(QKeyEvent *e)
{
	MainWindow->handle_key(e);
}
