//
// C++ Interface: dzwonekgraph
//
// Description: 
//
//
// Author: Szymon Acedanski <accek@podlesie.net>, (C) 2004
// Copyright (C) 2005, 2006  Krzysztof Mazur <krzysiek@podlesie.net>
//
// Copyright: See COPYING file that comes with this distribution
//
//

#include <qcolor.h>
#include <qstring.h>

#include "control.h"
#include "bufferedwidget.h"

class DzwonekGraph : public BufferedWidget {
	Q_OBJECT

private:
	class Signal {
	public:
		int physical;
		QColor acolor;
		QColor icolor;
		QString symbol;
		TimestampedList<BRecord>::Iterator iter;
		int x0;

		Signal() { }
		Signal(int physical, const QColor &acolor, const QColor &icolor,
				const QString& symbol)
			: physical(physical), acolor(acolor), icolor(icolor),
			symbol(symbol) { }
	};

	Signal sigs[16];
	int nsigs;
	int lineHeight;

	int nextStep();
	void resetSteps(unsigned long long ts);

protected:
	void paint(QPainter *p);

public:
	DzwonekGraph(QWidget *parent = 0, const char *name = 0,
			Qt::WFlags f = 0);

	void addSignal(int physical, QColor acolor, QColor icolor,
				   const QString &symbol);
};
