/*
 * ar3cmonitor - onoffwidget.h
 *
 * Copyright (C) 2004  Szymon Acedanski <accek@podlesie.net>
 * Copyright (C) 2006..2011  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifndef ONOFFWIDGET_H_INCLUDED
#define ONOFFWIDGET_H_INCLUDED

#include <qwidget.h>
#include <qstring.h>
#include <qcolor.h>
#include "bufferedwidget.h"

class OnOffLabel : public BufferedWidget {
	Q_OBJECT
private:
	QColor activecolor;
	QColor inactivecolor;
	QString Text;
	int physical;
	bool active;

protected:
	void paint(QPainter *p);
	void mousePressEvent(QMouseEvent *e);

public:
	OnOffLabel(const QString &caption, QColor _activecolor,
			QColor _inactivecolor, QWidget *parent = 0,
			const char *name = 0, Qt::WFlags f = 0);

	void setText(const QString &caption);
	void setActiveColor(QColor c);
	void setInActiveColor(QColor c);
	QString text();

public slots:
	void on();
	void off();

signals:
	void clicked();
};

#endif
