/*
 * ar3cctrl - signature.h
 * Copyright (C) 2008  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#ifndef __SIGNATURE_H
#define __SIGNATURE_H

#include <stddef.h>
#include <token.h>

struct signature {
	struct token *token;
	void *priv;
};

#ifdef __cplusplus
extern "C" {
#endif

int signature_init(struct signature *s);
int signature_set_token(struct signature *s, struct token *token);
int signature_reset(struct signature *s);
int signature_update(struct signature *s, const void *buf, size_t size);
int signature_size(struct signature *s);
int signature_generate(struct signature *s, void *buf);
int signature_verify(struct signature *s, const void *buf, size_t size);
int signature_destroy(struct signature *s);

#ifdef __cplusplus
};
#endif

#endif
