#include "tclocklabel.h"
#include "control.h"
#include <time.h>
	
TClockLabel::TClockLabel(const char *frm, QWidget *parent, const char *name, Qt::WFlags f)
    : QWidget(parent, name, f)
{
	l = new QVBoxLayout(this);
	
	lb = new QLabel("<center><font size=\"+2\" color=\"black\">"
			"<b>YY:MM:DD HH:MM:SS</b></font></center>", this);
	l->addWidget(lb);

	format = strdup(frm);
	connect(CO, SIGNAL(sigUpdateTimer()), SLOT(update_time()));
}

TClockLabel::~TClockLabel()
{
	free(format);
	delete lb;
	delete l;
}

void TClockLabel::update_time()
{
#if QT_VERSION >= 0x30000
	if (!isShown())
		return;
#endif

	unsigned long long stamp = CO->cursorStamp();
	time_t tim = stamp / 1000000000ULL;
	struct tm *tm = localtime(&tim);

	if (!tm)
		return;

	char t[256];
//	strftime(t, sizeof(t), "%d %b %Y  %H:%M:%S", tm);
	strftime(t, sizeof(t), format, tm);
	if (("<center><font size=\"+2\" color=\"black\">"
		"<b>" + QString(t) + "</b></font></center>") != lb->text())
		lb->setText("<center><font size=\"+2\" color=\"black\">"
		"<b>" + QString(t) + "</b></font></center>");
	
}
