/*
 * ar3cmonitor - test-scale.c 
 * Copyright (C) 2011  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Fundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <tscale.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

int exit_status = EXIT_SUCCESS;

static unsigned long long time_ns(void)
{
	struct timespec tv;

	clock_gettime(CLOCK_MONOTONIC, &tv);
	return tv.tv_sec * 1000000000ULL + tv.tv_nsec;
}

#define test(a, b) \
	do { \
		if (strcmp(a, b)) { \
			fprintf(stderr, "error: line %d, is \"%s\", " \
					"should be \"%s\"\n", __LINE__, a, b); \
			exit_status = EXIT_FAILURE; \
		} \
	} while (0)

int main(void)
{
	unsigned int i;
	int w;
	int x = 0;
	unsigned long long t = 110000000000ULL;
	unsigned long long t0 = 100000000000ULL;
	unsigned long long trange = 60000000000ULL;
	unsigned long long ts;

	ts = time_ns();
	for (i = 0; i < 1000000; i++) {
		w = tscale(t, t0, 1024, trange);
		t += 1;
		x += w;
	}
	ts = time_ns() - ts;

	printf("%.3f ms, %.3f ns per call (%d)\n", ts / 1000000.0,
			ts / 1000000.0, x);

	exit(exit_status);
}
